#include <iostream>
#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n,q;
    bool p=true;
    cin>>n>>q;
    vector<long long> a(n);
    vector<int> resenja(q);
    for(int i=0;i<n;i++){
        cin>>a[i];
        if(a[i]>8){
            p=false;
        }
    }
        for(int i=0;i<q;i++){
            int l;
            int r;
            cin>>l>>r;
            l--;
            r--;
            int brmaxi=1;
            int br=1;
            for(int j=l;j<r;j++){
                br=1;
                for(int k=l+1;k<=r;k++){
                    if((a[j] and a[k]) > (a[j] xor a[k])){
                        br++;
                    }
                }
                if(br>brmaxi){
                    brmaxi=br;
                }
            }
            resenja[i]=brmaxi;
        }

    for(int i=0;i<q;i++){
        cout<<resenja[i]<<endl;
    }
    return 0;
}